import 'package:fastor_app_ui_widget/fastor_app_ui_widget.dart';
import 'package:flutter/material.dart';
import 'package:flutter_clean_calendar/flutter_clean_calendar.dart';

class CalendarTemplate extends StatefulWidget {

  ValueChanged<DateTime> selectDate;

  CalendarTemplate( {
    required this.selectDate });

  @override
  CalendarState createState() {
    return CalendarState();
  }

}

class CalendarState extends State<CalendarTemplate> {

  DateTime? selectedDay;
  List <CleanCalendarEvent>? selectedEvent;


  @override
  Widget build(BuildContext context) {
    return _cleanCalenderView();
  }



  Widget _cleanCalenderView(){

    var cal = _getCalenderClean();


    //space + decoration
    var cont =  Container( child:  cal ,
      padding: EdgeInsets.all( DSDimen.space_level_2),
      margin: EdgeInsets.all(DSDimen.space_level_2),
      // color: Colors.yellow,          //background color


      decoration: BoarderHelper.cardView(
        colorBackground: DSColor.calendar_card_background,
        colorLine: DSColor.calendar_card_line
      ),
    );

    var mat =  Material( child:  cont,);

    // return mat;
    var box = SizedBox( child:  mat , height: 350 ,);

    return box;
  }


  Widget _getCalenderClean() {
    return Calendar(
      startOnMonday: true,
      selectedColor: DSColor.calendar_selected_background, //selected day background circle color
      todayColor: DSColor.calendar_selected_background,     //today background selected circle color
      eventColor: Colors.green,    //event : not used event
      eventDoneColor: Colors.amber, //event : not used event
      bottomBarColor: Colors.deepOrange, //event : not used event
      onRangeSelected: (range) {     //
        //Log.i('_cleanCalenderView() - selected range - ${range.from}, ${range.to}');
      },
      onDateSelected: (date){
       // Log.i('_cleanCalenderView() - onDateSelected - ${date} ');
        return _handleData(date);
      },
      events: events,
      isExpanded: true,
      dayOfWeekStyle: TextStyle(
        fontSize: 15,
        // fontFamily: FontProject.beach,
        color: Colors.black,                //week color
        fontWeight: FontWeight.w500,       //fond used
      ),
      bottomBarTextStyle: TextStyle(
        color: Colors.white,
      ),
      hideBottomBar: false,
      hideArrows: false,
      weekDays: ['Mon','Tue','Wed','Thu','Fri','Sat','Sun'],
    );

  }

  void _handleData(date){
    setState(() {
      selectedDay = date;
      selectedEvent = events[selectedDay] ?? [];
    });

    //callbacl
    widget.selectDate( date);
  }


  final Map<DateTime,List<CleanCalendarEvent>> events = {
    // DateTime (DateTime.now().year,DateTime.now().month,DateTime.now().day):
    // [
    //   CleanCalendarEvent('Event A',
    //       startTime: DateTime(
    //           DateTime.now().year,DateTime.now().month,DateTime.now().day,10,0),
    //       endTime:  DateTime(
    //           DateTime.now().year,DateTime.now().month,DateTime.now().day,12,0),
    //       description: 'A special event',
    //       color: Colors.blue //Colors.blue[700]
    //   ),
    // ],
  };


}